
#include <cstdio>
#include <map>
#include <string>
#include <algorithm>
using namespace std;

map<string,int> name2id;

int n;
char names[10][31];
int nitems[10];
int items[10][102];
int pers[10][102];

char buf[100];
char name_buf[100];

int find_idx(int t,int id){
	for(int i=0;i<nitems[t];i++)
		if(items[t][i] == id) return i;
	return -1;
}

int calc(int t, int idx, bool high){
	if(pers[t][idx] != -1) return pers[t][idx];
	int rem = 200;
	int pre = 0;
	bool spe = false;
	int same = 0;
	int beg = high ? nitems[t]-1 : 0;
	int end = high ? 0 : nitems[t]-1;
	int di  = high ? -1 : 1;
	for(int i= beg; i!=end+di; i+=di){
		if(i == idx){
			spe = true;
			same++;
		}else if(pers[t][i]!= -1){
			spe = false;
			pre = pers[t][i];
			if(pre==0) pre=1;
			rem -= pers[t][i];
		}else if(spe){
			same++;
		}else{
			rem -= pre;
		}
	}
	int score;
	if(high){
		score = rem/same;
	}else{
		score = rem/same + (rem%same?1:0);
	}
	if(score<1) score = 1;
	while(pers[t][idx] == -1) idx+= di;
	if(high){
		return min(score, pers[t][idx]);
	}else{
		return max(score, pers[t][idx]);
	}
}

int main(void){
	while(true){
		scanf("%d", &n);
		if(!n) break;
		name2id.clear();
		for(int i=0;i<n;i++){
			scanf("%s", names[i]);
			scanf("%d", &nitems[i]);
			gets(buf);
			items[i][0] = -1;
			pers[i][0] = 100;
			for(int j=0;j<nitems[i];j++){
				gets(buf);
				int t;
				int ret = sscanf(buf,"%s %d", name_buf, &t);
				string s = name_buf;
				int id;
				if(name2id.find(s) == name2id.end()){
					id = name2id.size();
					name2id[s] = id;
				}else{
					id = name2id[s];
				}
				items[i][j+1] = id;
				if(ret == 1){
					pers[i][j+1] = -1;
				}else{
					pers[i][j+1] = t;
				}
			}
			items[i][nitems[i]+1] = -1;
			pers[i][nitems[i]+1] = 0;
			nitems[i]+=2;
		}
		int q;
		scanf("%d", &q);
		while(q--){
			char ope[10];
			char trg_name[100];
			scanf("%s %s", ope, trg_name);
			int trg_id;
			string trg_name_s = trg_name;
			if(name2id.find(trg_name_s) == name2id.end()){
				for(int i=0; i<n;i++){
					if(i != 0) printf(" ");
					printf("%s", names[i]);
				}
				puts("");
				continue;
			}else{
				trg_id = name2id[trg_name_s];
			}
			int data[10][2];
			for(int i=0;i<n;i++){
				int idx = find_idx(i, trg_id);
				if(idx == -1){
					data[i][0] = data[i][1] = 0;
					continue;
				}
				data[i][0] = calc(i,idx,true);
				data[i][1] = calc(i,idx,false);
			}
			bool printed = false;
			bool ope_most = ope[0] == 'm';
			for(int i=0; i<n;i++){
				bool ok = true;
				for(int j=0;j<n;j++){
					if(i==j) continue;
					if( ope_most && data[i][0]<data[j][1]) ok = false;
					if(!ope_most && data[i][1]>data[j][0]) ok = false;
				}
				if(ok){
					if(printed) printf(" ");
					printed = true;
					printf("%s", names[i]);
				}
			}
			puts("");
		}
	}
	return 0;
}
